<?
/*============================================
 α׷  :  Tycoon Series Board ver 1.0
         :  Ÿ
         :  2002 2 5
 homepage  :  http://www.tycoon.pe.kr
            :  Խ, ڷ, 
============================================*/

class Layout_Class {
	var $LayoutPass, $ClassVars;
	var $contents = array();
	function Layout_Class($ClassVars) {
		$this->LayoutPass = $ClassVars[root_dir]."/layout/".$ClassVars[board_skin]."/";
		$ClassVars[image_url] = $ClassVars[root_url]."/layout/".$ClassVars[board_skin]."/image";
		if($ClassVars[admin_skin]=="admin") {
			$this->LayoutPass = $ClassVars[root_dir]."/layout/".$ClassVars[admin_skin]."/";
			$ClassVars[image_url] = $ClassVars[root_url]."/layout/".$ClassVars[admin_skin]."/image";
		}
		$this->ClassVars = $ClassVars;
	}
	/////////////////////////////////////////////////////////////////////////////////// [Default_define]
	function Default_define() {
		$this->contents[ICON_URL] = $this->ClassVars[icon_url];	
		$this->contents[ROOT_URL] = $this->ClassVars[root_url];
		$this->contents[IMAGE_URL] = $this->ClassVars[image_url];
		$this->contents[PAGE] = $this->ClassVars[page];
		$this->contents[KEY] = urlencode($this->ClassVars[key]);
		$this->contents[KEYFIELD] = $this->ClassVars[keyfield];
		$this->contents[SORT] = $this->ClassVars[sort];
		
		$this->contents[BOARD]=$this->ClassVars[board]; 
		$this->contents[BOARD_TITLE]=$this->ClassVars[board_title]; 
		$this->contents[BOARD_HEAD]=$this->ClassVars[board_head]; 
		$this->contents[BOARD_STYLE]=$this->ClassVars[board_style]; 
		$this->contents[BOARD_BODY]=$this->ClassVars[board_body]; 
		$this->contents[BOARD_HEADER]=$this->ClassVars[board_header];
		$this->contents[BOARD_FOOTER]=$this->ClassVars[board_footer];
		$this->contents[BOARD_WIDTH]= $this->ClassVars[board_width]; 
	}
	/////////////////////////////////////////////////////////////////////////////////// [Print_view]
	function Print_view($filename, $contents="", $view_contents="", $loop_contents="", $loop_num="", $return="") {
		$result = $this->File_read($filename, $contents, $view_contents, $loop_contents, $loop_num);
		echo $result;
	}
	/////////////////////////////////////////////////////////////////////////////////// [Return_view]
	function Return_view($filename, $contents="", $view_contents="", $loop_contents="", $loop_num="") {
		$result = $this->File_read($filename, $contents, $view_contents, $loop_contents, $loop_num);
		return $result;
	}
	/////////////////////////////////////////////////////////////////////////////////// [File_read]
	function File_read($filename, $contents, $view_contents, $loop_contents, $loop_num) {
		if($filename) { 
			$this->contents = $contents;
			$this->view_contents = $view_contents;
			$this->Default_define();
			
			$file = $this->LayoutPass .$filename;
			$line = file($file);
			while(list($key, $val) = each($line)) {
				if(ereg("<!--%%%LOOPSTART%%%-->", $val, $regs)) {
					$val = "";
					$loop = "y";
				} else if(ereg("<!--%%%LOOPEND%%%-->", $val, $regs)) {
					$val = "";
					$loop = "";
					$result .= $this->Loop_view($loop_var, $loop_contents, $loop_num);
					unset($loop_var);
				} else if(ereg("<!--@@[A-Z0-9_]+@@-->", $val, $regs)) $hidden_line = $this->Line_confirm($val);
				else if(ereg("<!--@@@END@@@-->", $val, $regs)) $hidden_line = "";
				
				if($loop) $loop_var[$key] = $val;
				else if(!$hidden_line) {
					$val = ereg_replace("<!--@@[A-Z0-9_]+@@-->", "", $val);
					$val = ereg_replace("<!--@@@END@@@-->", "", $val);
					$result .= $this->Split_line($val);
				}
			}
		} else {
            while(list($key, $val ) = each($contents)) {
      			$result .= $contents[$key];
            }
		}
		return $result;
	}
	/////////////////////////////////////////////////////////////////////////////////// [Loop_view]
	function Loop_view($loop_var, $loop_contents, $loop_num) {
		for($i=0; $i<$loop_num; $i++) {
			$this->Loop_define($loop_contents, $i);
			$result .= $this->Loop_contents($loop_var);
		}
		return $result;
	}
	/////////////////////////////////////////////////////////////////////////////////// [Loop_define]
	function Loop_define($loop_contents, $i) {
		while(list($key, $val) = each($loop_contents)) {
			$this->contents[$key] = $val[$i];
		}
	}
	/////////////////////////////////////////////////////////////////////////////////// [Loop_contents]
	function Loop_contents($loop_var) {
		while(list($key, $val) = each($loop_var)) {
			if(ereg("<!--@@[A-Z0-9_]+@@-->", $val, $regs)) $hidden_line = $this->Line_confirm($val);
			else if(ereg("<!--@@@END@@@-->", $val, $regs)) $hidden_line = "";
			if(!$hidden_line) {
				$val = ereg_replace("<!--@@[A-Z0-9_]+@@-->", "", $val);
				$val = ereg_replace("<!--@@@END@@@-->", "", $val);
				$result .= $this->Split_line($val);
			}
		}
		return $result;
	}
	/////////////////////////////////////////////////////////////////////////////////// [Line_confirm]
	function Line_confirm($what) {
		$what = trim($what);
		for($i=0; $i<sizeof($this->view_contents); $i++) {
			$val = "<!--@@".$this->view_contents[$i]."@@-->";
			if($what == $val) $view = "y";
		}
		$hidden = (!$view) ? "y": "";
		return $hidden;
	}
	/////////////////////////////////////////////////////////////////////////////////// [Split_line]
	function Split_line($line) {
		$split_val = split("({[A-Z0-9_]+})", $line);
		
		for($i=0; $i<sizeof($split_val)-1; $i++) {
			if(ereg("({[A-Z0-9_]+})",$line, $regs)) {
				$print = $this->Print_define($regs[1]);
				$line = ereg_replace($regs[1],"$print",$line);
			}
		}
		return $line;
	}
	/////////////////////////////////////////////////////////////////////////////////// [Print_define]
	function Print_define($what) {
		$what_val = str_replace("{", "", $what);
		$what_val = str_replace("}", "", $what_val);
		$print = $this->contents[$what_val];
		return $print;
	}
}
?>