<?
/*============================================
 α׷  :  Tycoon Series Board ver 1.0
         :  Ÿ
         :  2002 2 5
 homepage  :  http://www.tycoon.pe.kr
            :  Խ, ڷ, 
============================================*/

class common_class extends Layout_Class {
	var $ClassVar;
	
	function common_class($ClassVar) {
		$this->ClassVar = $ClassVar;
		$this->Layout_Class($ClassVar);
	}
	////////////////////////////////////////////////////////////////////// [popup_msg]
    function popup_msg($msg) {
		
		echo "
			<script language='javascript'> 
        		alert('".$msg."');
        		history.back();
        	</script>";
		exit;
    }
	////////////////////////////////////////////////////////////////////// [move]
	function move($ref, $sec="") {
		
		if(!$sec) $sec = 0;
		$url = $this->ClassVar[root_url]."/".$ref;
		echo "<meta http-equiv='Refresh' content='".$sec."; URL=".$url."'>";
		exit();
	}
	////////////////////////////////////////////////////////////////////// [print_select]
	function print_select($value, $option, $start="", $end="", $array="") {
		
		if($option) {
			while(list($key, $val) = each($option)) {
				if($array) {
					$result .= ($value == $key) ? "<option value='".$key."' selected>".$val."": "<option value='".$key."'>".$val."";
				}else{
					$result .= ($value == $val) ? "<option value='".$val."' selected>".$val."": "<option value='".$val."'>".$val."";
				}
			}
		} else {
			for($i = $start; $i <= $end; $i++) {
				$result .= ($value == $i) ? "<option value='".$i."' selected>".$i."": "<option value='".$i."'>".$i."";
			}
		}
		return $result;
	}
	////////////////////////////////////////////////////////////////////// [Ishangul]
	function Ishangul($strSrc, $pos) { 
		
		$hangul = 1; 
		for($i=0 ; $i<$pos ; ++$i) {
			ord($strSrc[$i]) > 127 ? ++$hangul : $hangul = -1; 
		}
		return $hangul%2; 
	} 
	////////////////////////////////////////////////////////////////////// [string_cut]
	function string_cut($strSrc, $start, $end="") { 
		
		$pos = $end + $start;
		if($this->IsHangul($strSrc, $pos)==0) --$end;
		
		return substr($strSrc, $start, $end); 
	}
	////////////////////////////////////////////////////////////////////// [html_char]
	function html_char($string, $plus=""){
		
		if($plus) $string = ereg_replace("'", '"', $string);
		if($this->ClassVar[html]) {
			$string = $this->quote_action($string);
			$string = ereg_replace("<\?", "&lt;?", $string);
			$string = ereg_replace("\?>", "?&gt;", $string);
			$string = ereg_replace("<\%", "&lt;%", $string);
			$string = ereg_replace("\%>", "%&gt;", $string);
			$string = eregi_replace("<(SCRIPT)([^>]*)>", "&lt;\\1\\2&gt;", $string);
			$string = eregi_replace("</(SCRIPT)>", "&lt;/\\1&gt;", $string);
			$string = eregi_replace("<(XMP)([^>]*)>", "&lt;\\1\\2&gt;", $string);
			$string = eregi_replace("</(XMP)>", "&lt;/\\1&gt;", $string);
		}else {
			$string = htmlspecialchars($string, ENT_QUOTES);
		}
		return $string;
	}
	////////////////////////////////////////////////////////////////////// [word_limit]
	function word_limit($string, $limitNo, $dot="") {
		
		$stringLength = strlen($string);  
		if($stringLength >= $limitNo) {
			$plus = $limitNo+1 ;
			$string = $this->string_cut($string, "", $plus);
			if(!$dot) $string = $string . " ...";
		}
		return $string;
	}
	////////////////////////////////////////////////////////////////////// [line_erase]
	function line_erase($string, $plus=""){
		
		$string = eregi_replace("\r\n", " ".$plus."", $string);	
		$string = eregi_replace("\n", " ".$plus."", $string);
		
		return $string;
	}
	////////////////////////////////////////////////////////////////////// [slashes]
	function slashes($string, $plus=""){
		
		if(!isset($plus) || empty($plus)) {
			if(get_magic_quotes_gpc()) return $string;
			else return addslashes($string); 
		}
		if($plus=="strip") {
		 	return stripslashes($string); 
		}
	}	
	////////////////////////////////////////////////////////////////////// [quote_action]
	function quote_action($string) { 
		
		$single = htmlspecialchars("'", ENT_QUOTES);
		$double = htmlspecialchars('"');
		
		$string = eregi_replace("'", $single, $string);
		$string = eregi_replace('"', $double, $string);
		
		$string = $this->slashes($string, "strip");
		
		return $string;
	}
	////////////////////////////////////////////////////////////////////// [reform]
	function reform($article) { 
		
		while(list($key, $val) = each($article)) {
			if($key != "mode") {
				$val = $this->quote_action($val);
	      		$result .= "<input type=hidden name=".$key." value=\"".$val."\">";
			}	
        }
		
		return $result;
	}
	////////////////////////////////////////////////////////////////////// [page_return]
	function page_return($Pvars, $msg) {
		
		global $PHP_SELF;
		
		$mode = explode("_", $Pvars[mode]);
		$reform = $this->reform($Pvars);
		
		echo"
			<form method=post name=page_return action='".$PHP_SELF."?".$this->ClassVar[queryString]."&mode=".$mode[0]."&no=".$Pvars[no]."'>
				".$reform."
			</form>
			<script language=JavaScript>
				alert('".$msg."');
				document.page_return.submit();
			</script>
		";
		exit();
	}
	////////////////////////////////////////////////////////////////////// [query_string]
	function query_string($page="") {
		
		$encodekey = urlencode($this->ClassVars[key]);
		
		$string = array(
			"board"=>$this->ClassVar[board], 
			"key"=>$encodekey, 
			"keyfield"=>$this->ClassVar[keyfield], 
			"sort"=>$this->ClassVar[sort]);
		
		if(!$page) $string[page] = $this->ClassVar[page]; 
		
		while(list($key, $value) = each($string)) {
			$result .= "&".$key."=".$value."";
		}
		
		if($page) return substr($result, 1);
		else $this->ClassVar[queryString] = substr($result, 1);
	}
	////////////////////////////////////////////////////////////////////// [total_count]
	function total_count() {
		
		$WhereClause = ($this->ClassVar[keyfield]) ? $this->ClassVar[keyfield]." LIKE '%".$this->ClassVar[key]."%'" : "board_notice='0'";
		
		$db = mysql_query("select count(board_num) from ".$this->ClassVar[board]." where ".$WhereClause."");
		$TotalNo = (mysql_num_rows($db)!=0) ? mysql_result($db,0,0) : 0;
		
		if (!$this->ClassVar[page]) $this->ClassVar[page] = 0;
		$EndPage = Ceil($TotalNo / $this->ClassVar[NumofList]) - 1;
		if($EndPage < $this->ClassVar[page]) $this->ClassVar[page] = $EndPage;
		
		if ($this->ClassVar[page] == $EndPage) 
			$ListEnd = $TotalNo - ($this->ClassVar[page] * $this->ClassVar[NumofList]);
		else $ListEnd = $this->ClassVar[NumofList];  
		
		$DataNo = $this->ClassVar[page] * $this->ClassVar[NumofList];
		
		$result = array($TotalNo, $EndPage, $ListEnd, $DataNo);
		return $result;
	}
	////////////////////////////////////////////////////////////////////// [page_link]
    function page_link($EndPage, $write_BT) {
		
		global $PHP_SELF;
		
		$queryString = $this->query_string(1);
		
		if ($this->ClassVar[page] > 0) {
			$PrevLink =  $this->ClassVar[page] - 1;
			$PrevBT = "PREV_BT";
		}
		
		if ($this->ClassVar[page] < $EndPage) {
			$NextLink =  $this->ClassVar[page] + 1;
			$NextBT = "NEXT_BT";
		}
		
		$PageBase = ceil($this->ClassVar[NumofBlock]/2); 
		
		if($PageBase < $this->ClassVar[page]+1) { 
			$PrevBlockNo = $this->ClassVar[page] - $this->ClassVar[NumofBlock];
			if($PrevBlockNo<0) $PrevBlockNo=0;
			$PrevBlock = "PREV_BLOCK_YESLINK";
		} else { 
			$PrevBlock = "PREV_BLOCK_NOLINK"; 
		}
		
		$Start = 0;
		$row = 0;
		
		for($i=0; $i<$this->ClassVar[NumofBlock]; $i++){
			if($PageBase < $this->ClassVar[page]+1) $Start = $this->ClassVar[page]-($PageBase-1);
			$RealPage = $Start + $i;
			$ViewPage = $RealPage + 1;
			$PageNo[$row] = ($this->ClassVar[page] == $RealPage) ? "<b>".$ViewPage."</b>" : "<a href=".$PHP_SELF."?page=".$RealPage."&".$queryString.">".$ViewPage."</a>";
			$row++;
			if ($RealPage>=$EndPage) break;
		}
		
		if($RealPage<$EndPage){ 
			$NextBlockNo = $this->ClassVar[page]+$this->ClassVar[NumofBlock]; 
			if($NextBlockNo>$EndPage) $NextBlockNo = $EndPage;
			$NextBlock = "NEXT_BLOCK_YESLINK";
		} else $NextBlock = "NEXT_BLOCK_NOLINK";  
		
		$PageResult = $this->Return_view("paging.html", 
			array(
				"PHP_SELF"=>$PHP_SELF, 
				"QUERY_STRING"=>$queryString, 
				"NUM_OF_BLOCK"=>$this->ClassVar[NumofBlock], 
				"END_PAGE"=>$EndPage, 
				"PREV_LINK"=>$PrevLink, 
				"NEXT_LINK"=>$NextLink, 
				"PREV_BLOCKNO"=>$PrevBlockNo, 
				"NEXT_BLOCKNO"=>$NextBlockNo), 
			array(
				$PrevBlock, $NextBlock, $PrevBT, $NextBT, $write_BT), 
			array(
				"PAGE_NO"=>$PageNo),
			$row);
		return $PageResult;
	}
}
?>
